datablock AudioProfile(llShotgunFireSound)
{
	filename = "./llshotgun_fire.wav";
	description = AudioClose3d;
	preload = true;
};

datablock AudioProfile(llShotgunReloadSound)
{
	filename = "./llshotgun_reload.wav";
	description = AudioClose3d;
	preload = true;
};

datablock DebrisData(llShotgunCasingDebris)
{
	shapeFile = "./shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -1500.0;
	maxSpinSpeed = -600.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(llShotgunFlashParticle)
{
	dragCoefficient = 3;
	gravityCoefficient = -0.5;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 25;
	lifetimeVarianceMS = 15;
	textureName = "base/data/particles/star1";
	spinSpeed = 10.0;
	spinRandomMin = -500.0;
	spinRandomMax = 500.0;
	colors[0] = "0.6 0.6 0.3 0.7";
	colors[1] = "0.9 0.5 0.0 0.0";
	sizes[0] = 0.25;
	sizes[1] = 2.25;

	useInvAlpha = false;
};

datablock ParticleEmitterData(llShotgunFlashEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 1.0;
	velocityVariance = 1.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "llShotgunFlashParticle";

	uiName = "";
};

datablock ParticleData(llShotgunSmokeParticle)
{
	dragCoefficient = 3;
	gravityCoefficient = -0.5;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 1000;
	lifetimeVarianceMS = 55;
	textureName = "base/data/particles/cloud";
	spinSpeed = 10.0;
	spinRandomMin = -500.0;
	spinRandomMax = 500.0;
	colors[0] = "0.4 0.4 0.4 0.3";
	colors[1] = "0.4 0.4 0.4 0.0";
	sizes[0] = 0.40;
	sizes[1] = 0.8;

	useInvAlpha = false;
};

datablock ParticleEmitterData(llShotgunSmokeEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 0;
	ejectionVelocity = 2.0;
	velocityVariance = 0.5;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "llShotgunSmokeParticle";

	uiName = "";
};

datablock ParticleData(llShotgunBulletTrailParticle)
{
	dragCoefficient		= 3;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.15;
	constantAcceleration = 0.0;
	lifetimeMS			 = 550;
	lifetimeVarianceMS	= 0;
	textureName			= "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]	= "0.7 0.8 0.3 0.3";
	colors[1]	= "0.4 0.5 0.2 0.2";
	colors[2]	= "0.2 0.3 0.2 0.1";
	colors[3]	= "0.0 0.0 0.0 0.0";

	sizes[0]		= 0.04;
	sizes[1]		= 0.30;
	sizes[2]		= 0.07;
 	sizes[3]		= 0.04;

	times[0] = 0.0;
	times[1] = 0.05;
	times[2] = 0.3;
	times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(llShotgunBulletTrailEmitter)
{
	ejectionPeriodMS = 6;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset	= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel  = 0;
	phiVariance		= 360;
	overrideAdvance = false;
	particles = "llShotgunBulletTrailParticle";
};

AddDamageType("llShotgun", '<bitmap:add-ons/Weapon_Lil_Shotguns/CI_llShotgun> %1', '%2 <bitmap:add-ons/Weapon_Lil_Shotguns/CI_llShotgun> %1', 0.2, 1);
datablock ProjectileData(llShotgunProjectile)
{
	// custom bullet shape
	projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
	
	// it's a shotgun, so low damage
	directDamage = 7;
	directDamageType = $DamageType::llShotgun;
	radiusDamageType = $DamageType::llShotgun;

	// I seriously dislike it when guns break bricks
	brickExplosionRadius = 0;
	brickExplosionImpact = false;
	brickExplosionForce = 0;
	brickExplosionMaxVolume = 0;
	brickExplosionMaxVolumeFloating = 0;

	// not much knockback
	impactImpulse = 150;
	verticalImpulse = 100;
	
	// if you're missing this, something is very wrong
	explosion = gunExplosion; 
	particleEmitter = llShotgunBulletTrailEmitter;

	// a little bit faster than the default gun
	muzzleVelocity = 145;
	velInheritFactor = 1;

	// same as default gun
	armingDelay = 0;
	lifetime = 1000;
	fadeDelay = 500;
	bounceElasticity = 0.5;
	bounceFriction = 0.20;
	isBallistic = false;
	gravityMod = 0.0;

	hasLight = false;
	lightRadius = 3.0;
	lightColor = "0 0 0.5";
	
	uiName = "Lil' Shotgun Bullet";
};

// large, up-close bullet
datablock ProjectileData(llShotgunBlastProjectile : llShotgunProjectile)
{
	// if you're missing this, something is very wrong
	projectileShapeName = "add-ons/Vehicle_Tank/tankbullet.dts";
	directDamage		  = 50;

	// launch far
	impactImpulse		  = 500;
	verticalImpulse	  = 100;

	// slower than main projectile
	muzzleVelocity		= 100;
	velInheritFactor	 = 1;

	// nothing to see here...
	armingDelay			= 0;
	lifetime				= 70;
	fadeDelay			  = 0;
	isBallistic			= true;
	gravityMod = 0.0;
};

// recoil effects
datablock ExplosionData(llShotgunRecoilExplosion)
{
	explosionShape = "";

	lifeTimeMS = 150;

	faceViewer		 = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "2 2 2";
	camShakeAmp = "0.3 0.5 0.4";
	camShakeDuration = 0.5;
	camShakeRadius = 10.0;
};
datablock ProjectileData(llShotgunRecoilProjectile)
{
	lifetime	= 10;
	fadeDelay	= 10;
	explodeondeath	= true;
	explosion	= llShotgunRecoilExplosion;
};

datablock ItemData(llShotgunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./llshotgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Lil' Shotguns";
	
	// make this later
	iconName = "./icon_llshotgun";
	
	doColorShift = true;
	colorShiftColor = "0.340 0.225 0.10 1.000";

	image = llShotgunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(llShotgunImage)
{
	shapeFile = "./llshotgun.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = llShotgunItem;
	ammo = " ";
	projectile = llShotgunProjectile;
	projectileType = Projectile;
	
	casing = llShotgunCasingDebris;
	shellExitDir		  = "0.5 -0.3 1.2";
	shellExitOffset	  = "0 0 0";
	shellExitVariance	= 7.0;	
	shellVelocity		 = 6.5;

	melee = false;
	armReady = true;

	// copy the colorshift values from the item
	doColorShift = true;
	colorShiftColor = llShotgunItem.colorShiftColor;
	
	// muh states
	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.15;
	stateTransitionOnTimeout[0] = "Ready";
	stateSound[0] = weaponSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1] = true;

	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Smoke";
	stateTimeoutValue[2] = 0.03;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateSequence[2] = "fire";
	stateScript[2] = "onFire";
	stateWaitForTimeout[2] = true;
	stateEmitter[2] = llShotgunFlashEmitter;
	stateEmitterTime[2] = 0.05;
	stateEmitterNode[2] = "muzzleNode";
	stateSound[2] = llShotgunFireSound;

	stateName[3] = "Smoke";
	stateEmitter[3] = llShotgunSmokeEmitter;
	stateEmitterTime[3] = 0.05;
	stateEmitterNode[3] = "muzzleNode";
	stateTimeoutValue[3] = 0.2;
	stateWaitForTimeout[3] = true;
	stateTransitionOnTimeout[3] = "Reload";

	stateName[4] = "Reload";
	stateSequence[4] = "reload";
	stateEjectShell[4] = true;
	stateTimeoutValue[4] = 0.2;
	stateWaitForTimeout[4] = true;
	stateTransitionOnTimeout[4] = "CheckFire";
	stateSound[4] = llShotgunReloadSound;
	
	stateName[5] = "CheckFire";
	stateAllowImageChange[5] = false;
	stateTransitionOnTriggerDown[5] = "FireAkimbo";
	stateTransitionOnTriggerUp[5] = "Ready";

	stateName[6] = "FireAkimbo";
	stateTimeoutValue[6] = 0.43;
	stateScript[6] = "onFireAkimbo";
	stateTransitionOnTimeOut[6] = "ready";
};

datablock ShapeBaseImageData(llLeftHandedShotgunImage)
{
	shapeFile = "./llshotgun.dts";
	emap = true;

	mountPoint = 1;
	offset = "0 0 0";
	eyeOffset = 0;
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = llShotgunItem;
	ammo = " ";
	projectile = llShotgunProjectile;
	projectileType = Projectile;
	
	casing = llShotgunCasingDebris;
	shellExitDir		  = "1.2 2.0 2.0";
	shellExitOffset	  = "0 0 0";
	shellExitVariance	= 5.0;	
	shellVelocity		 = 4.5;

	melee = false;
	armReady = false;

	// copy the colorshift values from the item
	doColorShift = true;
	colorShiftColor = llShotgunItem.colorShiftColor;
	
	// muh states
	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.15;
	stateTransitionOnTimeout[0] = "Ready";
	stateSound[0] = weaponSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1] = true;

	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Smoke";
	stateTimeoutValue[2] = 0.03;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateSequence[2] = "fire";
	stateScript[2] = "onFire";
	stateWaitForTimeout[2] = true;
	stateEmitter[2] = llShotgunFlashEmitter;
	stateEmitterTime[2] = 0.05;
	stateEmitterNode[2] = "muzzleNode";
	stateSound[2] = llShotgunFireSound;

	stateName[3] = "Smoke";
	stateEmitter[3] = llShotgunSmokeEmitter;
	stateEmitterTime[3] = 0.05;
	stateEmitterNode[3] = "muzzleNode";
	stateTimeoutValue[3] = 0.2;
	stateWaitForTimeout[3] = true;
	stateTransitionOnTimeout[3] = "Reload";

	stateName[4] = "Reload";
	stateSequence[4] = "reload";
	stateEjectShell[4] = true;
	stateTimeoutValue[4] = 0.2;
	stateWaitForTimeout[4] = true;
	stateTransitionOnTimeout[4] = "Done";
	stateSound[4] = llShotgunReloadSound;

	stateName[5] = "Done";
	stateTimeoutValue[5] = 0.43;
	stateTransitionOnTimeOut[5] = "ready";
};

function llShotgunImage::onFire(%this, %obj, %slot)
{	
	if(%obj.getDamagePercent() < 1.0)
	{
		%obj.spawnExplosion(llShotgunRecoilProjectile, "1 1 1");

		%obj.playThread(0, jump);
		
		// %obj.addVelocity(VectorScale(VectorScale(%obj.getMuzzleVector(%slot), -1), 4.5));
		
		// spawn the big projectile (llShotgunBlastProjectile)
		%blast = new Projectile()
		{
			dataBlock = llShotgunBlastProjectile;
			initialVelocity = VectorScale(%obj.getMuzzleVector(%slot), llShotgunBlastProjectile.muzzleVelocity);
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%blast);

		%shellcount = 6;
		for(%shell = 0; %shell < %shellcount; %shell++)
		{
			%projectile = %this.projectile;
			%factor = 0.055;

			%vector = VectorAdd(VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity), VectorScale(%obj.getVelocity(), %projectile.velInheritFactor));
			%matrix = MatrixCreateFromEuler(((getRandom() - 0.5) * 10 * 3.1415926 * (%factor / 10)) @ " " @ ((getRandom() - 0.5) * 10 * 3.1415926 * (%factor / 10)) @ " " @ ((getRandom() - 0.5) * 10 * 3.1415926 * (%factor / 10)));
			%velocity = MatrixMulVector(%matrix, %vector);

			%p = new Projectile()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
	}
}

function llShotgunImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	%obj.mountImage(llLeftHandedShotgunImage, 1);
}

function llShotgunImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this, %obj, %slot);
	%obj.unMountImage(1);
}

function llShotgunImage::onFireAkimbo(%this, %obj, %slot)
{
	%obj.setImageTrigger(1, 1);
}

function llLeftHandedShotgunImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	%obj.playThread(1, armReadyBoth);
}

function llLeftHandedShotgunImage::onUnMount(%this, %obj, %slot)
{
	Parent::onUnMount(%this, %obj, %slot);
}

function llLeftHandedShotgunImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() < 1.0)
	{
		%obj.spawnExplosion(llShotgunRecoilProjectile, "1 1 1");

		%obj.playThread(0, jump);
		
		// %obj.addVelocity(VectorScale(VectorScale(%obj.getMuzzleVector(%slot), -1), 4.5));
		
		// spawn the big projectile (llShotgunBlastProjectile)
		%blast = new Projectile()
		{
			dataBlock = llShotgunBlastProjectile;
			initialVelocity = VectorScale(%obj.getMuzzleVector(%slot), llShotgunBlastProjectile.muzzleVelocity);
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%blast);
		
		%shellcount = 6;
		for(%shell = 0; %shell < %shellcount; %shell++)
		{
			%projectile = %this.projectile;
			%factor = 0.055;

			%vector = VectorAdd(VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity), VectorScale(%obj.getVelocity(), %projectile.velInheritFactor));
			%matrix = MatrixCreateFromEuler(((getRandom() - 0.5) * 10 * 3.1415926 * (%factor / 10)) @ " " @ ((getRandom() - 0.5) * 10 * 3.1415926 * (%factor / 10)) @ " " @ ((getRandom() - 0.5) * 10 * 3.1415926 * (%factor / 10)));
			%velocity = MatrixMulVector(%matrix, %vector);

			%p = new Projectile()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
	}
}
